Robot Simulator of the Robotics Group for Self-Organization of Control: OneLayerFFNN Class Reference

- Main Page
- Namespaces
- Classes
- Files
- Directories
- Related Pages
- Examples

- Search for |

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# OneLayerFFNN Class Reference

simple one layer neural network with configurable activation function More...

`#include <onelayerffnn.h>`

Inherits FeedForwardNN.

Inheritance diagram for OneLayerFFNN:

[legend]
Collaboration diagram for OneLayerFFNN:

[legend]
List of all members.

## Public Member Functions
| OneLayerFFNN (double eps, double factor_bias=0.1)
| Uses linear activation function.
| OneLayerFFNN (double eps, double factor_bias, ActivationFunction actfun, ActivationFunction dactfun)
virtual | ~OneLayerFFNN ()
virtual void | init (unsigned int inputDim, unsigned int outputDim, double unit_map=0.0, RandGen *randGen=0)
| initialisation of the network with the given number of input and output units
virtual const matrix::Matrix | process (const matrix::Matrix &input)
| passive processing of the input
virtual const matrix::Matrix | learn (const matrix::Matrix &input, const matrix::Matrix &nom_output, double learnRateFactor=1)
| performs learning and returns the network output before learning
virtual unsigned int | getInputDim () const
| returns the number of input neurons
virtual unsigned int | getOutputDim () const
| returns the number of output neurons
virtual const matrix::Matrix & | getWeights () const
virtual const matrix::Matrix & | getBias () const
virtual void | damp (double damping)
| damps the weights and the biases by multiplying (1-damping)
bool | store (FILE *f) const
| stores the layer binary into file stream
bool | restore (FILE *f)
| restores the layer binary from file stream
virtual paramkey | getName () const
| return the name of the object
virtual paramval | getParam (const paramkey key) const
virtual bool | setParam (const paramkey key, paramval val)
virtual paramlist | getParamList () const
| The list of all parameters with there value as allocated lists.

## Detailed Description

simple one layer neural network with configurable activation function

## Constructor & Destructor Documentation

OneLayerFFNN | ( | double | eps,
|  | double | factor_bias = `0.1` |
| ) |  |  | `[inline]`

Uses linear activation function.

Parameters:

  | eps | learning rate
  | factor_bias | learning rate factor for bias learning

OneLayerFFNN | ( | double | eps,
|  | double | factor_bias,
|  | ActivationFunction | actfun,
|  | ActivationFunction | dactfun |
| ) |  |  | `[inline]`

Parameters:

  | eps | learning rate
  | factor_bias | learning rate factor for bias learning
  | actfun | callback activation function (see FeedForwardNN)
  | dactfun | callback for first derivative of the activation function

virtual ~OneLayerFFNN | ( |  | ) | `[inline, virtual]`

## Member Function Documentation

virtual void damp | ( | double | damping | ) | `[inline, virtual]`

damps the weights and the biases by multiplying (1-damping)

Implements FeedForwardNN.

virtual const matrix::Matrix& getBias | ( |  | ) | const`[inline, virtual]`

virtual unsigned int getInputDim | ( |  | ) | const`[inline, virtual]`

returns the number of input neurons

Implements AbstractModel.

virtual paramkey getName | ( |  | ) | const`[inline, virtual]`

return the name of the object

Reimplemented from Configurable.

virtual unsigned int getOutputDim | ( |  | ) | const`[inline, virtual]`

returns the number of output neurons

Implements AbstractModel.

virtual paramval getParam | ( | const paramkey | key | ) | const`[inline, virtual]`

virtual paramlist getParamList | ( |  | ) | const`[inline, virtual]`

The list of all parameters with there value as allocated lists.

Note that these are only parameters that are managed manually (with setParam, getParam)

See also:
  getAllParamNames()

Returns:
  list of key-value pairs

Reimplemented from Configurable.

virtual const matrix::Matrix& getWeights | ( |  | ) | const`[inline, virtual]`

void init | ( | unsigned int | inputDim,
|  | unsigned int | outputDim,
|  | double | unit_map = `0.0`,
|  | RandGen * | randGen = `0` |
| ) |  |  | `[virtual]`

initialisation of the network with the given number of input and output units

Implements AbstractModel.

const Matrix learn | ( | const matrix::Matrix & | input,
|  | const matrix::Matrix & | nom_output,
|  | double | learnRateFactor = `1` |
| ) |  |  | `[virtual]`

performs learning and returns the network output before learning

Implements AbstractModel.

const Matrix process | ( | const matrix::Matrix & | input | ) | `[virtual]`

passive processing of the input

Implements AbstractModel.

bool restore | ( | FILE * | f | ) | `[virtual]`

restores the layer binary from file stream

Implements Storeable.

virtual bool setParam | ( | const paramkey | key,
|  | paramval | val |
| ) |  |  | `[inline, virtual]`

bool store | ( | FILE * | f | ) | const`[virtual]`

stores the layer binary into file stream

Implements Storeable.

The documentation for this class was generated from the following files:

- onelayerffnn.h
- onelayerffnn.cpp